/*
	Copyright  1986, 1987, 1989, 1989, 1990 Network Innovations Corporation.
	All Rights Reserved.
	CL/1 is a trademark of Network Innovations Corporation.
	This software may not be used without permission from
	Network Innovations Corporation.
*/

/* SUCCESS and WARNING status codes */

# define C_OK		0L	/* successful completion */
# define C_NOMORE	100L	/* no more data */
# define C_ISNULL	1L	/* NULL data */

/* ERROR status codes compatible with DB2 */

#define CECHAR		-7L	/* illegal character in statement */
#define CEQUOTE		-10L	/* unterminated string constant */
#define CESYNTAX	-84L	/* unacceptable statement */
#define CECOMPLEX	-101L	/* stmt too long or complex */
#define CENUMLIT	-103L	/* invalid numeric literal */
#define CETOKEN		-104L	/* invalid token */
#define CESTRLIT	-105L	/* invalid string literal */
#define CENAMLEN	-107L	/* identifier name too long */
#define CECLAUSE	-109L	/* clause not permitted */
#define CEFCNARG	-111L	/* fcn without column name */
#define CEINVARG	-112L	/* nested fcns or other illegal args */
#define CENAMINV	-113L	/* invalid identifier name */
#define CEPRDINV	-115L	/* invalid predicate */
#define CEINSCNT	-117L	/* insert cols/vals count mismatch */
#define CESRCDST	-118L	/* same tbl is src & dest in update */
#define CEHAVCOL	-119L	/* HAVING col not in GROUP BY clause */
#define CEINVREF	-120L	/* where/set references fcn or group col */
#define CEDUPCOL	-121L	/* dup col name in insert/update list */
#define CESELGRP	-122L	/* select/group/agg clause disagreement */
#define CESRTNUM	-125L	/* illegal colnr in ORDER BY clause */
#define CEUPDSRT	-126L	/* UPDATE & ORDER BY clauses conflict */
#define CEDISTINCT	-127L	/* too many DISTINCT keywords */
#define CEUSENUL	-128L	/* invalid use of NULL in predicate */
#define CETBLCNT	-129L	/* too many table names */
#define CELIKE		-131L	/* LIKE with incompatible data types */
#define CELIKARG	-132L	/* LIKE has wrong arguments */
#define CECORHAV	-133L	/* fcn on correlated ref in HAVING clause */
#define CEVARBIN	-134L	/* illegal opn on long unstructured data */
#define CESRTLEN	-136L	/* too many/too long SORT/GROUP BY cols */
#define CENUPVIEW	-150L	/* update of non-updateable view */
#define CENUPCOL	-151L	/* update of non-updateable column */
#define CEGRPVIEW	-155L	/* FROM clause includes grouped view */
#define CEINVVIEW	-161L	/* update violates VIEW constraints */
#define CEKEYWORD	-199L	/* invalid use of keyword */
#define CEAMBIG		-203L	/* ambiguous column reference */
#define CEUDFIDN	-204L	/* ref to undefined identifier */
#define CECOLTBL	-205L	/* unknown column for table */
#define CEUDFCOL	-206L	/* unknown column name for any table */
#define CECOLSRT	-208L	/* unknown col ref in ORDER BY clause */
#define CEVARTYP	-303L	/* invalid data type for variable */
#define CEVARRNG	-304L	/* data out of range for data type */
#define CEUDFVAR	-312L	/* undefined/unusable variable name */
#define CEOPTYP		-401L	/* incompatible operands for operator */
#define CENUMCHR	-402L	/* numeric operation on character data */
#define CECOLLEN	-404L	/* string too long for column on upd/ins */
#define CELITRNG	-405L	/* numeric literal out of range */
#define CEVALRNG	-406L	/* calculated value out of range */
#define CENONNUL	-407L	/* NULL assigned to NON-NULL column */
#define CECOLTYP	-408L	/* upd/ins data has invalid type for column */
#define CECNTOP		-409L	/* invalid operand of COUNT() fcn */
#define CEFLTLEN	-410L	/* floating point literal too long */
#define CEUSER		-411L	/* keyword USER improperly used */
#define CESUBCOL	-412L	/* illegal multi-column subquery */
#define CECNVOFL	-413L	/* numeric overflow during type conversion */
#define CELIKNUM	-414L	/* LIKE on numeric column */
#define CESCALE		-419L	/* negative scale on decimal division */
#define CECRSNOP	-501L	/* cursor (or other object) not open */
#define CECRSOPN	-502L	/* cursor (or other object) already open */
#define CEUPDLST	-503L	/* column not in FOR UPDATE list */
#define CEUDFCRS 	-504L 	/*specified cursor is not defined for this operation*/
#define CENOT2OPEN	-507L	/* cursor (upd/del) not open */
#define CECURROW	-508L	/* cursor not positioned on a row */
#define CECRSNUP	-510L	/* non-updateable cursor */
#define CETBLNUP	-511L	/* non-updateable table */
#define CEOBJPRV	-551L	/* privilege violation on object */
#define CEOPNPRV	-552L	/* privilege violation for operation */
#define CEEXISTS	-601L	/* object of given name already exists */
#define CEOFLOW		-802L	/* arithmetic overflow */
#define CEDUPROW	-803L	/* ins/upd would create duplicate row */
#define CESUBCNT	-811L	/* subquery produces multi-row result */
#define CEGRPHAV	-815L	/* illegal GROUP/HAVING in subquery */
#define CECOLCNT	-840L	/* too many items in select/insert list */
#define CESYSTEM	-901L	/* non-fatal system error */
#define CEFATAL		-904L	/* fatal system error */
#define CETXROLL	-911L	/* txn rolled back, deadlock/timeout */
#define CETXFAIL	-913L	/* txn failed, deadlock/timeout */
#define CECONAUTH	-922L	/* database open authorization failure */
#define CENOCON		-923L	/* database not opened */
#define CEDB2CON	-924L	/* DB2 internal connection error */

/* CL/1 syntax errors */

#define CECOMMENT  -10001L /* unterminated comment */
#define CEDATLIT   -10002L /* invalid date/time literal */
#define CENOTHERE  -10003L /* language construct not allowed in that context */
#define CEUNDEF    -10004L /* undefined identifier */
#define CEEXP      -10005L /* (some) token expected */
#define CEUNEXP    -10006L /* (some) token unexpected */
#define CESYN      -10007L /* syntax error */
#define CEMISNG    -10008L /* (some) token missing */
#define CEINVID    -10009L /* invalid CL/1 ident */
#define CEILLOP    -10010L /* invalid CL/1 operator use */
#define CEREDCL    -10011L /* illegal redeclaration of ident */
#define CESEM      -10012L /* sementic error, construct does not make sense */
#define CEILLASN   -10013L /* illegal assignment to CL/1 variable */
#define CEILLPRT   -10014L /* printing not allowed now */
#define CEILLTYP   -10015L /* illegal type for operation or type mismatch */
#define CENOVAL    -10016L /* variable has no value yet */
#define CERECUR    -10017L /* recursion not allowed here */
#define CEPCNT     -10018L /* function call parameter count is wrong */
#define CERCNT     -10019L /* function call return item count is wrong */
#define CENOQRY    -10020L /* no query associated with (default) cursor */
#define CENOFTCH   -10021L /* no fetch done yet (no current row) */
#define CEMXFTCH   -10022L /* fetch beyond last (no current row) */
#define CEFTCHOP   -10023L /* bad fetch op for fetch mode */
#define CENOTXNS   -10024L /* DB does not support transactions */
#define CEPRECIS   -10025L /* loss of precision on conversion */
#define CEUFLOW	   -10026L /* conversion resulted in underflow */
#define CECOLVAL   -10027L /* insert/update value illegal for col */


/* CL/1 operational errors -- object manipulation */

#define CEOPEN		-10101L	/* error opening object */
#define CECLOSE		-10102L	/* error closing object */
#define CERENAME	-10103L /* error renaming object */
#define CEDELETE	-10104L /* error deleting object */
#define CELOCK		-10105L	/* object locked by another user */
#define CEISOPEN	-10106L	/* object is already open */
#define CENOTOPEN	-10107L	/* object is not open */
#define CEFILEIO	-10108L	/* file i/o error on access */
#define CEPRTIO		-10109L	/* printer i/o error */
#define CENETIO		-10110L	/* network i/o error */
#define CEPROTOCOL	-10111L /* protocol not supported */
#define CENOMEM		-10112L	/* insufficient memory for operation */
#define CEBREAK		-10113L	/* break request interrupted operation */
#define CEUNIMPL	-10114L	/* unimplemented feature/function */
#define CETOOMANY	-10115L	/* object/item maximum exceeded */
#define CECOPY		-10116L	/* error copying object */
#define CECREATE	-10117L	/* error creating object */
#define CELOGIN		-10118L	/* invalid login parameters */
#define CETIMOUT	-10119L	/* timeout on request */

#define CEPARM          -10150L /* illegal parameter */
#define CEFORK          -10151L /* unable to run subprocess */


/* CL/1 execution errors -- data manipulation */

#define CEBRAND		-10200L	/* unknown dbms brand specified */
#define CEDBREV		-10201L	/* incompatible DBMS rev levels */
#define CEROWNR		-10202L	/* bad row nr specified */
#define CESUBTBL	-10203L	/* main & subquery FROM names dup table */
#define CEUDFTBL	-10204L	/* undefined table name in database */
#define CEDUPTBL	-10205L /* duplicate table/synonym name in from list */
#define CECATALOG	-10206L	/* error accessing database catalogs */
#define CEDBMS		-10207L	/* untranslated DBMS error */
#define CEALIAS		-10208L	/* undefined alias specified */

#define CEUDFALS        -10209L /* table (or alias) not in from list */
#define CEDBOPEN        -10211L /* no database is open */

/* CL/1 client only errors */

#define CENETIOC	-10628L		/* network I/O error on client */
#define CENETMODE	-10629L		/* network send/recv mode error */
#define CEIOPORT	-10630L		/* error opening I/O port */
#define CEMODEM		-10631L		/* error on modem */
#define CECONNECT	-10632L		/* connection error */
#define CEVERSION	-10634L		/* version incompatibility */
#define CESHUTDOWN	-10635L		/* could not shut down host server */
#define CENOSERVER	-10636L		/* no server */
#define CEATTMDM	-10637L		/* too many modem attempts */
#define CEINIMDM	-10638L		/* could not init modem */
#define CELOGPRM	-10640L		/* invalid login parameters */
#define CEPASPRM	-10641L		/* invalid password parameter */
#define CEAUTLOG	-10642L		/* error during auto-login */
#define CEINIHST	-10643L		/* error initializing host */
#define CEHUPMDM	-10644L		/* error hanging up modem */
#define CEIBMENT	-10645L		/* te not allowed */
#define CENETLD		-10646L		/* ? */
#define CECTRLBRK	-10647L		/* modem contol error */

/* CL/1 configuration and internal errors */

#define CECONFIG	-10901L	/* CL/1 server configuration problem */
#define CEINTID		-10902L	/* invalid object-id specified */
#define CEINTCTX	-10903L	/* internal - invalid txn for context */
#define CEINTCNT	-10904L	/* internal - count mismatch */
#define CEINTTYP	-10905L	/* unknown data type in DBMS */
#define CEINTTXN	-10906L	/* operation at wrong time in txn */
#define CEINTPARM	-10907L	/* internal parameter error */
#define CEINTDBIF	-10908L	/* dbms interface error */
#define CEINTNET	-10909L	/* network interface error */
#define CEINTOSIF	-10910L	/* opsys interface error */
#define CEUNSPEC	-10911L /* unspecified error */

